#include <screen.h>
#include <gdt.h>
#include <idt.h>
#include <timer.h>
#include <fault_handlers.h>
#include <paging.h>

int main(struct multiboot *mboot_ptr)
{
	// Initialization
	init_scr();
	init_gdt();
	init_idt(); // includes IRQs
	init_timer(50);
	init_fault_handlers();
	init_paging((16*1024)); // For now we presume 16 MB
	
	m_puts("Fenyx v0.1 a0 build 12");
	
	return 0;
}
