#ifndef PAGING_H
#define PAGING_H

#include "typedefs.h"

typedef struct
{
	u32int present		: 1;
	u32int rw			: 1; // read-write
	u32int user			: 1;
	u32int writethrough	: 1;
	u32int cachedisable	: 1;
	u32int accessed		: 1;
	u32int alwayszero	: 1;
	u32int size			: 1; // 0 = 4-kB, 1 = 4-mB
	u32int ignored		: 1;
	u32int available	: 3;
	u32int address		: 20;
} page_dirent_t;

typedef struct
{
	u32int present		: 1;
	u32int rw			: 1; // read-write
	u32int user			: 1;
	u32int writethrough	: 1;
	u32int cachedisable	: 1;
	u32int accessed		: 1;
	u32int dirty		: 1;
	u32int alwayszero	: 1;
	u32int global		: 1;
	u32int available	: 3;
	u32int address		: 20;
} page_t;

typedef struct
{
	page_dirent_t table[1024];
} page_dir_t;

typedef struct
{
	page_t table[1024];
} page_table_t;

void init_paging(u32int mem_in_kb);
#endif // PAGING_H
